Package: QZ
Version: 0.2-4
Date: 2025-04-12
Title: Generalized Eigenvalues and QZ Decomposition
Authors@R: c(person("Wei-Chen", "Chen", role = c("aut", "cre"), email=
    "wccsnow@gmail.com"), person("LAPACK authors", role = c("aut", "cph")))
Depends: R (>= 3.6.0), methods, Matrix
Suggests: fda
LazyLoad: yes
LazyData: yes
Copyright: See QZ/inst/LAPACK_LICENSE.txt for the files in src/qz/.
Description: Generalized eigenvalues and eigenvectors
        use QZ decomposition (generalized Schur decomposition).
        The decomposition needs an N-by-N non-symmetric
        matrix A or paired matrices (A,B) with eigenvalues reordering
        mechanism. The decomposition functions are mainly based Fortran
        subroutines in complex*16 and double precision of LAPACK
        library (version 3.10.0 or later).
License: Mozilla Public License 2.0
NeedsCompilation: yes
Maintainer: Wei-Chen Chen <wccsnow@gmail.com>
Packaged: 2025-04-13 00:19:15 UTC; snoweye
Author: Wei-Chen Chen [aut, cre],
  LAPACK authors [aut, cph]
Repository: CRAN
Date/Publication: 2025-04-13 04:40:02 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-26 01:38:51 UTC; unix
Archs: QZ.so.dSYM

Package: QZ
Version: 0.2-4
Date: 2025-04-12
Title: Generalized Eigenvalues and QZ Decomposition
Authors@R: c(person("Wei-Chen", "Chen", role = c("aut", "cre"), email=
    "wccsnow@gmail.com"), person("LAPACK authors", role = c("aut", "cph")))
Depends: R (>= 3.6.0), methods, Matrix
Suggests: fda
LazyLoad: yes
LazyData: yes
Copyright: See QZ/inst/LAPACK_LICENSE.txt for the files in src/qz/.
Description: Generalized eigenvalues and eigenvectors
        use QZ decomposition (generalized Schur decomposition).
        The decomposition needs an N-by-N non-symmetric
        matrix A or paired matrices (A,B) with eigenvalues reordering
        mechanism. The decomposition functions are mainly based Fortran
        subroutines in complex*16 and double precision of LAPACK
        library (version 3.10.0 or later).
License: Mozilla Public License 2.0
NeedsCompilation: yes
Maintainer: Wei-Chen Chen <wccsnow@gmail.com>
Packaged: 2025-04-13 00:19:15 UTC; snoweye
Author: Wei-Chen Chen [aut, cre],
  LAPACK authors [aut, cph]
Repository: CRAN
Date/Publication: 2025-04-13 04:40:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-27 11:51:34 UTC; unix
Archs: QZ.so.dSYM

useDynLib(QZ)
import(methods)
import(Matrix)

### S3 functions
exportPattern("^qz\\.[[:alpha:]]+")
exportPattern("^[[:alpha:]]+")

### S3 methods
S3method(print, zgees)
S3method(print, zgeev)
S3method(print, ztrsen)

S3method(print, zgges)
S3method(print, zggev)
S3method(print, ztgsen)

S3method(print, dgees)
S3method(print, dgeev)
S3method(print, dtrsen)

S3method(print, dgges)
S3method(print, dggev)
S3method(print, dtgsen)

# QZ

* **License:** [![License](http://img.shields.io/badge/license-MPL%202-orange.svg?style=flat)](https://www.mozilla.org/MPL/2.0/)
* **Download:** [![Download](http://cranlogs.r-pkg.org/badges/QZ)](https://cran.r-project.org/package=QZ)
* **Status:** [![Build Status](https://gitlab.com/snoweye/QZ/badges/master/pipeline.svg)](https://gitlab.com/snoweye/QZ/-/commits/master) [![Appveyor Build status](https://ci.appveyor.com/api/projects/status/32r7s2skrgm9ubva?svg=true)](https://ci.appveyor.com/project/snoweye/QZ)
* **Author:** Wei-Chen Chen

QZ is an R package providing QZ factorization for generalized eigenvalues and eigenvectors via QZ decomposition (generalized Schur decomposition). Typically, the decomposition needs an N-by-N non-symmetric matrix A or paired matrices (A,B) with eigenvalues reordering mechanism. The decomposition functions are mainly based Fortran subroutines in complex\*16 and double precision of LAPACK library (version 3.4.2. or later).  

## QZ requires

* R version 3.6.0 or higher.
* For installing QZ, see ``INSTALL`` file for details.
* More information about QZ can be found in the QZ vignette at ``QZ/inst/doc/QZ-guide.pdf``.

library(QZ, quiet = TRUE)

### Generate Data
set.seed(123)
X <- matrix(rnorm(500), nrow = 25)
X <- t(X) %*% X
A <- X[1:8, 9:20]
B <- X[1:8, 1:8]
C <- X[9:20, 9:20]

### Perform generalized eigenanalysis 
ret.qz <- fda.geigen(A, B, C)
ret.fda <- fda::geigen(A, B, C)

### Verify
round(abs(ret.qz$values - ret.fda$values))
round(abs(ret.qz$Lmat - ret.fda$Lmat))
round(abs(ret.qz$Mmat - ret.fda$Mmat))

library(QZ, quiet = TRUE)

### https://www.netlib.org/lapack/lug/node122.html
(ret <- geigen(exAB1$A, exAB1$B))

### https://www.netlib.org/lapack/lug/node117.html
(ret <- geigen(exAB2$A, exAB2$B))

### https://www.netlib.org/lapack/lug/node92.html
(ret <- geigen(exA1$A))

### https://www.netlib.org/lapack/lug/node87.html
(ret <- geigen(exA2$A))

library(QZ, quiet = TRUE)

### https://www.netlib.org/lapack/lug/node122.html
A <- exAB1$A
B <- exAB1$B
ret <- qz.zggev(A, B)

# Verify 1
(lambda <- ret$ALPHA / ret$BETA)    # Unstable
diff.R <- matrix(ret$BETA, 4, 4, byrow = TRUE) * A %*% ret$V -
          matrix(ret$ALPHA, 4, 4, byrow = TRUE) * B %*% ret$V
diff.L <- matrix(ret$BETA, 4, 4) * H(ret$U) %*% A -
          matrix(ret$ALPHA, 4, 4) * H(ret$U) %*% B
round(diff.R)
round(diff.L)

# Verify 2
round(ret$U %*% solve(ret$U))
round(ret$V %*% solve(ret$V))

library(QZ, quiet = TRUE)

### https://www.netlib.org/lapack/lug/node124.html
(ret <- qz(exAB1$A, exAB1$B))

### https://www.netlib.org/lapack/lug/node119.html
(ret <- qz(exAB2$A, exAB2$B))

### https://www.netlib.org/lapack/lug/node94.html
(ret <- qz(exA1$A))

### https://www.netlib.org/lapack/lug/node89.html
(ret <- qz(exA2$A))

library(QZ, quiet = TRUE)

### Get eigenvalues
A <- exA2$A
ret0 <- qz.dgeev(A)
ret1 <- qz.dgees(A)

# Reordering eigenvalues
T <- ret1$T
Q <- ret1$Q
select <- c(TRUE, FALSE, FALSE, TRUE)
ret2 <- qz.dtrsen(T, Q, select)

# Verify 0
round(ret0$WR - ret1$WR)
round(ret0$WI - ret1$WI)

# Verify 1
A.new <- ret2$Q %*% ret2$T %*% solve(ret2$Q)
round(A - A.new)

# verify 2
round(ret2$Q %*% solve(ret2$Q))

library(QZ, quiet = TRUE)

### https://www.netlib.org/lapack/lug/node89.html
A <- exA2$A
ret <- qz.dgees(A)

# Verify 1
A.new <- ret$Q %*% ret$T %*% solve(ret$Q)
round(A - A.new)

# verify 2
round(ret$Q %*% solve(ret$Q))

library(QZ, quiet = TRUE)

### Get eigenvalues
A <- exAB1$A
B <- exAB1$B
ret0 <- qz.zggev(A, B)
ret1 <- qz.zgges(A, B)

# Reordering eigenvalues
S <- ret1$S
T <- ret1$T
Q <- ret1$Q
Z <- ret1$Z
select <- c(TRUE, FALSE, FALSE, TRUE)
ret2 <- qz.ztgsen(S, T, Q, Z, select)

# Verify 0
round(ret0$ALPHA - ret1$ALPHA)
round(ret0$BETA - ret1$BETA)

# Verify 1
A.new <- ret2$Q %*% ret2$S %*% H(ret2$Z)
B.new <- ret2$Q %*% ret2$T %*% H(ret2$Z)
round(A - A.new)
round(B - B.new)

# verify 2
round(ret2$Q %*% H(ret2$Q))
round(ret2$Z %*% H(ret2$Z))

# Reordering eigenvalues
library(QZ, quiet = TRUE)

select <- c(TRUE, FALSE, FALSE, TRUE)
(ret <- qz(exAB1$A, exAB1$B, select = select))

### https://www.netlib.org/lapack/lug/node119.html
select <- c(TRUE, FALSE, FALSE, TRUE)
(ret <- qz(exAB2$A, exAB2$B, select = select))
(ret <- ordqz(exAB2$A, exAB2$B, keyword = "ref"))
(ret <- ordqz(exAB2$A, exAB2$B, keyword = "cef"))

select <- c(TRUE, FALSE, FALSE, TRUE)
(ret <- qz(exA1$A, select = select))

### https://www.netlib.org/lapack/lug/node89.html
select <- c(TRUE, FALSE, FALSE, TRUE)
(ret <- qz(exA2$A, select = select))
(ret <- ordqz(exA2$A, keyword = "lhp"))
(ret <- ordqz(exA2$A, keyword = "rhp"))
(ret <- ordqz(exA2$A, keyword = "ref"))
(ret <- ordqz(exA2$A, keyword = "cef"))

library(QZ, quiet = TRUE)

### https://www.netlib.org/lapack/lug/node124.html
A <- exAB1$A
B <- exAB1$B
ret <- qz.zgges(A, B)

# Verify 1
A.new <- ret$Q %*% ret$S %*% H(ret$Z)
B.new <- ret$Q %*% ret$T %*% H(ret$Z)
round(A - A.new)
round(B - B.new)

# verify 2
round(ret$Q %*% H(ret$Q))
round(ret$Z %*% H(ret$Z))

library(QZ, quiet = TRUE)

### https://www.netlib.org/lapack/lug/node117.html
A <- exAB2$A
B <- exAB2$B
ret <- qz.dggev(A, B)

# Verify 1
(lambda <- ret$ALPHA / ret$BETA)    # Unstable
diff.R <- matrix(ret$BETA, 4, 4, byrow = TRUE) * A %*% ret$V -
          matrix(ret$ALPHA, 4, 4, byrow = TRUE) * B %*% ret$V
diff.L <- matrix(ret$BETA, 4, 4) * H(ret$U) %*% A -
          matrix(ret$ALPHA, 4, 4) * H(ret$U) %*% B
round(diff.R)
round(diff.L)

# Verify 2
round(ret$U %*% solve(ret$U))
round(ret$V %*% solve(ret$V))

library(QZ, quiet = TRUE)

### Get eigenvalues
A <- exAB2$A
B <- exAB2$B
ret0 <- qz.dggev(A, B)
ret1 <- qz.dgges(A, B)

# Reordering eigenvalues
S <- ret1$S
T <- ret1$T
Q <- ret1$Q
Z <- ret1$Z
select <- c(FALSE, TRUE, TRUE, FALSE)
ret2 <- qz.dtgsen(S, T, Q, Z, select)

# Verify 0
round(ret0$ALPHAR - ret1$ALPHAR)
round(ret0$ALPHAI - ret1$ALPHAI)
round(ret0$BETA - ret1$BETA)

# Verify 1
A.new <- ret2$Q %*% ret2$S %*% t(ret2$Z)
B.new <- ret2$Q %*% ret2$T %*% t(ret2$Z)
round(A - A.new)
round(B - B.new)

# verify 2
round(ret2$Q %*% t(ret2$Q))
round(ret2$Z %*% t(ret2$Z))

library(QZ, quiet = TRUE)

### https://www.netlib.org/lapack/lug/node94.html
A <- exA1$A
ret <- qz.zgees(A)

# Verify 1
A.new <- ret$Q %*% ret$T %*% H(ret$Q)
round(A - A.new)

# verify 2
round(ret$Q %*% H(ret$Q))

library(QZ, quiet = TRUE)

### Get eigenvalues
A <- exA1$A
ret0 <- qz.zgeev(A)
ret1 <- qz.zgees(A)

# Reordering eigenvalues
T <- ret1$T
Q <- ret1$Q
select <- c(TRUE, FALSE, FALSE, TRUE)
ret2 <- qz.ztrsen(T, Q, select)

# Verify 0
round(ret0$W - ret1$W)

# Verify 1
A.new <- ret2$Q %*% ret2$T %*% solve(ret2$Q)
round(A - A.new)

# verify 2
round(ret2$Q %*% solve(ret2$Q))

library(QZ, quiet = TRUE)

### https://support.nag.com/numeric/fl/nagdoc_fl23/xhtml/F08/f08quf.xml
T <- exA3$T
Q <- exA3$Q
select <- c(TRUE, FALSE, FALSE, TRUE)
ret <- qz.ztrsen(T, Q, select)

# Verify 1
A <- Q %*% T %*% solve(Q)
A.new <- ret$Q %*% ret$T %*% solve(ret$Q)
round(A - A.new)

# verify 2
round(ret$Q %*% solve(ret$Q))

library(QZ, quiet = TRUE)

### https://www.netlib.org/lapack/lug/node92.html
A <- exA1$A
ret <- qz.zgeev(A)

# Verify 1
diff.R <- A %*% ret$V - matrix(ret$W, 4, 4, byrow = TRUE) * ret$V
diff.L <- H(ret$U) %*% A - matrix(ret$W, 4, 4) * H(ret$U)
round(diff.R)
round(diff.L)

# Verify 2
round(ret$U %*% H(ret$U))
round(ret$V %*% H(ret$V))

library(QZ, quiet = TRUE)

### https://support.nag.com/numeric/fl/nagdoc_fl23/xhtml/F08/f08yuf.xml
S <- exAB3$S
T <- exAB3$T
Q <- exAB3$Q
Z <- exAB3$Z
select <- c(FALSE, TRUE, TRUE, FALSE)
ret <- qz.ztgsen(S, T, Q, Z, select)

# Verify 1
S.new <- ret$Q %*% ret$S %*% H(ret$Z)
T.new <- ret$Q %*% ret$T %*% H(ret$Z)
round(S - S.new)
round(T - T.new)

# verify 2
round(ret$Q %*% H(ret$Q))
round(ret$Z %*% H(ret$Z))

#!/bin/sh

echo "\n-- dexA1_zgees.r:"
Rscript dexA1_zgees.r

echo "\n-- dexA1_zgeev.r:"
Rscript dexA1_zgeev.r

echo "\n-- dexA2_zgees.r:"
Rscript dexA2_dgees.r

echo "\n-- dexA2_dgeev.r:"
Rscript dexA2_dgeev.r

echo "\n-- dexA3_ztrsen.r:"
Rscript dexA3_ztrsen.r

echo "\n-- dexA4_dtrsen.r:"
Rscript dexA4_dtrsen.r

echo "\n-- dexAB1_zgges.r:"
Rscript dexAB1_zgges.r

echo "\n-- dexAB1_zggev.r:"
Rscript dexAB1_zggev.r

echo "\n-- dexAB2_dgges.r:"
Rscript dexAB2_dgges.r

echo "\n-- dexA2_dgeev.r:"
Rscript dexAB2_dggev.r

echo "\n-- dexAB3_ztgsen.r:"
Rscript dexAB3_ztgsen.r

echo "\n-- dexAB4_dtgsen.r:"
Rscript dexAB4_dtgsen.r

echo "\n-- exA1_z.r:"
Rscript exA1_z.r

echo "\n-- exA2_d.r:"
Rscript exA2_d.r

echo "\n-- exAB1_z.r:"
Rscript exAB1_z.r

echo "\n-- exAB2_d.r:"
Rscript exAB2_d.r
